<?php

// Start of sodium v.7.2.7-0ubuntu0.18.04.2

/**
 * @link http://php.net/manual/en/class.sodiumexception.php
 */
class SodiumException extends Exception implements Throwable {
	protected $message;
	protected $code;
	protected $file;
	protected $line;


	/**
	 * (PHP 5, PHP 7)<br/>
	 * Clone the exception
	 * @link http://php.net/manual/en/exception.clone.php
	 * @return void No value is returned.
	 */
	final private function __clone(): void {}

	/**
	 * (PHP 5, PHP 7)<br/>
	 * Construct the exception
	 * @link http://php.net/manual/en/exception.construct.php
	 * @param string $message [optional] <p>
	 * The Exception message to throw.
	 * </p>
	 * @param int $code [optional] <p>
	 * The Exception code.
	 * </p>
	 * @param Throwable $previous [optional] <p>
	 * The previous exception used for the exception chaining.
	 * </p>
	 */
	public function __construct(string $message = "", int $code = 0, Throwable $previous = null) {}

	public function __wakeup() {}

	/**
	 * (PHP 5, PHP 7)<br/>
	 * Gets the Exception message
	 * @link http://php.net/manual/en/exception.getmessage.php
	 * @return string the Exception message as a string.
	 */
	final public function getMessage(): string {}

	/**
	 * (PHP 5, PHP 7)<br/>
	 * Gets the Exception code
	 * @link http://php.net/manual/en/exception.getcode.php
	 * @return mixed the exception code as integer in
	 * <b>Exception</b> but possibly as other type in
	 * <b>Exception</b> descendants (for example as
	 * string in <b>PDOException</b>).
	 */
	final public function getCode() {}

	/**
	 * (PHP 5, PHP 7)<br/>
	 * Gets the file in which the exception was created
	 * @link http://php.net/manual/en/exception.getfile.php
	 * @return string the filename in which the exception was created.
	 */
	final public function getFile(): string {}

	/**
	 * (PHP 5, PHP 7)<br/>
	 * Gets the line in which the exception was created
	 * @link http://php.net/manual/en/exception.getline.php
	 * @return int the line number where the exception was created.
	 */
	final public function getLine(): int {}

	/**
	 * (PHP 5, PHP 7)<br/>
	 * Gets the stack trace
	 * @link http://php.net/manual/en/exception.gettrace.php
	 * @return array the Exception stack trace as an array.
	 */
	final public function getTrace(): array {}

	/**
	 * (PHP 5 &gt;= 5.3.0, PHP 7)<br/>
	 * Returns previous Exception
	 * @link http://php.net/manual/en/exception.getprevious.php
	 * @return Throwable the previous <b>Throwable</b> if available
	 * or <b>NULL</b> otherwise.
	 */
	final public function getPrevious(): Throwable {}

	/**
	 * (PHP 5, PHP 7)<br/>
	 * Gets the stack trace as a string
	 * @link http://php.net/manual/en/exception.gettraceasstring.php
	 * @return string the Exception stack trace as a string.
	 */
	final public function getTraceAsString(): string {}

	/**
	 * (PHP 5, PHP 7)<br/>
	 * String representation of the exception
	 * @link http://php.net/manual/en/exception.tostring.php
	 * @return string the string representation of the exception.
	 */
	public function __toString(): string {}

}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Check if hardware supports AES256-GCM
 * @link http://php.net/manual/en/function.sodium-crypto-aead-aes256gcm-is-available.php
 * @return bool
 */
function sodium_crypto_aead_aes256gcm_is_available(): bool {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Decrypt in combined mode with precalculation
 * @link http://php.net/manual/en/function.sodium-crypto-aead-aes256gcm-decrypt.php
 * @param string $ciphertext <p>
 * </p>
 * @param string $ad <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_aead_aes256gcm_decrypt(string $ciphertext, string $ad, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Encrypt in combined mode with precalculation
 * @link http://php.net/manual/en/function.sodium-crypto-aead-aes256gcm-encrypt.php
 * @param string $msg <p>
 * </p>
 * @param string $ad <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_aead_aes256gcm_encrypt(string $msg, string $ad, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-aead-aes256gcm-keygen.php
 * @return string
 */
function sodium_crypto_aead_aes256gcm_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Verify that the ciphertext includes a valid tag
 * @link http://php.net/manual/en/function.sodium-crypto-aead-chacha20poly1305-decrypt.php
 * @param string $ciphertext <p>
 * </p>
 * @param string $ad <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_aead_chacha20poly1305_decrypt(string $ciphertext, string $ad, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Encrypt a message
 * @link http://php.net/manual/en/function.sodium-crypto-aead-chacha20poly1305-encrypt.php
 * @param string $msg <p>
 * </p>
 * @param string $ad <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_aead_chacha20poly1305_encrypt(string $msg, string $ad, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-aead-chacha20poly1305-keygen.php
 * @return string
 */
function sodium_crypto_aead_chacha20poly1305_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Verify that the ciphertext includes a valid tag
 * @link http://php.net/manual/en/function.sodium-crypto-aead-chacha20poly1305-ietf-decrypt.php
 * @param string $ciphertext <p>
 * </p>
 * @param string $ad <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_aead_chacha20poly1305_ietf_decrypt(string $ciphertext, string $ad, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Encrypt a message
 * @link http://php.net/manual/en/function.sodium-crypto-aead-chacha20poly1305-ietf-encrypt.php
 * @param string $msg <p>
 * </p>
 * @param string $ad <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_aead_chacha20poly1305_ietf_encrypt(string $msg, string $ad, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-aead-chacha20poly1305-ietf-keygen.php
 * @return string
 */
function sodium_crypto_aead_chacha20poly1305_ietf_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-aead-xchacha20poly1305-ietf-decrypt.php
 * @param string $ciphertext <p>
 * </p>
 * @param string $ad <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_aead_xchacha20poly1305_ietf_decrypt(string $ciphertext, string $ad, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-aead-xchacha20poly1305-ietf-keygen.php
 * @return string
 */
function sodium_crypto_aead_xchacha20poly1305_ietf_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-aead-xchacha20poly1305-ietf-encrypt.php
 * @param string $msg <p>
 * </p>
 * @param string $ad <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_aead_xchacha20poly1305_ietf_encrypt(string $msg, string $ad, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Compute a tag for the message
 * @link http://php.net/manual/en/function.sodium-crypto-auth.php
 * @param string $msg <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_auth(string $msg, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-auth-keygen.php
 * @return string
 */
function sodium_crypto_auth_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Verifies that the tag is valid for the message
 * @link http://php.net/manual/en/function.sodium-crypto-auth-verify.php
 * @param string $signature <p>
 * </p>
 * @param string $msg <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return bool
 */
function sodium_crypto_auth_verify(string $signature, string $msg, string $key): bool {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Encrypt a message
 * @link http://php.net/manual/en/function.sodium-crypto-box.php
 * @param string $msg <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box(string $msg, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Randomly generate a secret key and a corresponding public key
 * @link http://php.net/manual/en/function.sodium-crypto-box-keypair.php
 * @return string
 */
function sodium_crypto_box_keypair(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Deterministically derive the key pair from a single key
 * @link http://php.net/manual/en/function.sodium-crypto-box-seed-keypair.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box_seed_keypair(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-box-keypair-from-secretkey-and-publickey.php
 * @param string $secret_key <p>
 * </p>
 * @param string $public_key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box_keypair_from_secretkey_and_publickey(string $secret_key, string $public_key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Verify and decrypt a ciphertext
 * @link http://php.net/manual/en/function.sodium-crypto-box-open.php
 * @param string $ciphertext <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box_open(string $ciphertext, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-box-publickey.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box_publickey(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-box-publickey-from-secretkey.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box_publickey_from_secretkey(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Encrypt a message
 * @link http://php.net/manual/en/function.sodium-crypto-box-seal.php
 * @param string $msg <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box_seal(string $msg, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Decrypt the ciphertext
 * @link http://php.net/manual/en/function.sodium-crypto-box-seal-open.php
 * @param string $ciphertext <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box_seal_open(string $ciphertext, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-box-secretkey.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_box_secretkey(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Creates a new sodium keypair
 * @link http://php.net/manual/en/function.sodium-crypto-kx-keypair.php
 * @return string the new keypair on success; throws an exception otherwise.
 */
function sodium_crypto_kx_keypair(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-kx-publickey.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_kx_publickey(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-kx-secretkey.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_kx_secretkey(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-kx-seed-keypair.php
 * @param string $string <p>
 * </p>
 * @return string
 */
function sodium_crypto_kx_seed_keypair(string $string): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-kx-client-session-keys.php
 * @param string $client_keypair <p>
 * </p>
 * @param string $server_key <p>
 * </p>
 * @return array
 */
function sodium_crypto_kx_client_session_keys(string $client_keypair, string $server_key): array {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-kx-server-session-keys.php
 * @param string $server_keypair <p>
 * </p>
 * @param string $client_key <p>
 * </p>
 * @return array
 */
function sodium_crypto_kx_server_session_keys(string $server_keypair, string $client_key): array {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get a hash of the message
 * @link http://php.net/manual/en/function.sodium-crypto-generichash.php
 * @param string $msg <p>
 * </p>
 * @param string $key [optional] <p>
 * </p>
 * @param int $length [optional] <p>
 * </p>
 * @return string
 */
function sodium_crypto_generichash(string $msg, string $key = null, int $length = SODIUM_CRYPTO_GENERICHASH_BYTES): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-generichash-keygen.php
 * @return string
 */
function sodium_crypto_generichash_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Initialize a hash
 * @link http://php.net/manual/en/function.sodium-crypto-generichash-init.php
 * @param string $key [optional] <p>
 * </p>
 * @param int $length [optional] <p>
 * </p>
 * @return string
 */
function sodium_crypto_generichash_init(string $key = null, int $length = SODIUM_CRYPTO_GENERICHASH_BYTES): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Add message to a hash
 * @link http://php.net/manual/en/function.sodium-crypto-generichash-update.php
 * @param string $state <p>
 * </p>
 * @param string $msg <p>
 * </p>
 * @return bool
 */
function sodium_crypto_generichash_update(string &$state, string $msg): bool {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Complete the hash
 * @link http://php.net/manual/en/function.sodium-crypto-generichash-final.php
 * @param string $state <p>
 * </p>
 * @param int $length [optional] <p>
 * </p>
 * @return string
 */
function sodium_crypto_generichash_final(string &$state, int $length = SODIUM_CRYPTO_GENERICHASH_BYTES): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Derive a subkey
 * @link http://php.net/manual/en/function.sodium-crypto-kdf-derive-from-key.php
 * @param int $subkey_len <p>
 * </p>
 * @param int $subkey_id <p>
 * </p>
 * @param string $context <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_kdf_derive_from_key(int $subkey_len, int $subkey_id, string $context, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-kdf-keygen.php
 * @return string
 */
function sodium_crypto_kdf_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Derive a key from a password
 * @link http://php.net/manual/en/function.sodium-crypto-pwhash.php
 * @param int $length <p>
 * integer; The length of the password hash to generate, in bytes.
 * </p>
 * @param string $password <p>
 * string; The password to generate a hash for.
 * </p>
 * @param string $salt <p>
 * string A salt to add to the password before hashing. The salt should be unpredictable, ideally generated from a good random mumber source such as <b>random_bytes</b>, and have a length of at least <b>SODIUM_CRYPTO_PWHASH_SALTBYTES</b> bytes.
 * </p>
 * @param int $opslimit <p>
 * Represents a maximum amount of computations to perform. Raising this number will make the function require more CPU cycles to compute a key. There are some constants available to set the operations limit to appropriate values depending on intended use, in order of strength: <b>SODIUM_CRYPTO_PWHASH_OPSLIMIT_INTERACTIVE</b>, <b>SODIUM_CRYPTO_PWHASH_OPSLIMIT_MODERATE</b> and <b>SODIUM_CRYPTO_PWHASH_OPSLIMIT_SENSITIVE</b>.
 * </p>
 * @param int $memlimit <p>
 * The maximum amount of RAM that the function will use, in bytes. There are constants to help you choose an appropriate value, in order of size: <b>SODIUM_CRYPTO_PWHASH_MEMLIMIT_INTERACTIVE</b>, <b>SODIUM_CRYPTO_PWHASH_MEMLIMIT_MODERATE</b>, and <b>SODIUM_CRYPTO_PWHASH_MEMLIMIT_SENSITIVE</b>. Typically these should be paired with the matching opslimit values.
 * </p>
 * @param int $alg [optional] <p>
 * integer A number indicating the hash algorithm to use. By default <b>SODIUM_CRYPTO_PWHASH_ALG_DEFAULT</b> (the currently recommended algorithm, which can change from one version of libsodium to another), or explicitly using <b>SODIUM_CRYPTO_PWHASH_ALG_ARGON2I13</b>, representing the Argon2id algorithm version 1.3.
 * </p>
 * @return string the hashed password, or <b>FALSE</b> on failure.
 * </p>
 * <p>
 * The used algorithm, opslimit, memlimit and salt are embedded within the hash, so
 * all information needed to verify the hash is included. This allows
 * the <b>password_verify</b> function to verify the hash without
 * needing separate storage for the salt or algorithm information.
 */
function sodium_crypto_pwhash(int $length, string $password, string $salt, int $opslimit, int $memlimit, int $alg = null): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get an ASCII encoded hash
 * @link http://php.net/manual/en/function.sodium-crypto-pwhash-str.php
 * @param string $password <p>
 * </p>
 * @param int $opslimit <p>
 * </p>
 * @param int $memlimit <p>
 * </p>
 * @return string
 */
function sodium_crypto_pwhash_str(string $password, int $opslimit, int $memlimit): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Verify that hash is a valid password verification string
 * @link http://php.net/manual/en/function.sodium-crypto-pwhash-str-verify.php
 * @param string $hash <p>
 * </p>
 * @param string $password <p>
 * </p>
 * @return bool
 */
function sodium_crypto_pwhash_str_verify(string $hash, string $password): bool {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-pwhash-str-needs-rehash.php
 * @param string $password <p>
 * </p>
 * @param int $opslimit <p>
 * </p>
 * @param int $memlimit <p>
 * </p>
 * @return bool
 */
function sodium_crypto_pwhash_str_needs_rehash(string $password, int $opslimit, int $memlimit): bool {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Derives a key from a password
 * @link http://php.net/manual/en/function.sodium-crypto-pwhash-scryptsalsa208sha256.php
 * @param int $length <p>
 * </p>
 * @param string $password <p>
 * </p>
 * @param string $salt <p>
 * </p>
 * @param int $opslimit <p>
 * </p>
 * @param int $memlimit <p>
 * </p>
 * @return string
 */
function sodium_crypto_pwhash_scryptsalsa208sha256(int $length, string $password, string $salt, int $opslimit, int $memlimit): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get an ASCII encoded hash
 * @link http://php.net/manual/en/function.sodium-crypto-pwhash-scryptsalsa208sha256-str.php
 * @param string $password <p>
 * </p>
 * @param int $opslimit <p>
 * </p>
 * @param int $memlimit <p>
 * </p>
 * @return string
 */
function sodium_crypto_pwhash_scryptsalsa208sha256_str(string $password, int $opslimit, int $memlimit): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Verify that the password is a valid password verification string
 * @link http://php.net/manual/en/function.sodium-crypto-pwhash-scryptsalsa208sha256-str-verify.php
 * @param string $hash <p>
 * </p>
 * @param string $password <p>
 * </p>
 * @return bool
 */
function sodium_crypto_pwhash_scryptsalsa208sha256_str_verify(string $hash, string $password): bool {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Compute a shared secret given a user's secret key and another user's public key
 * @link http://php.net/manual/en/function.sodium-crypto-scalarmult.php
 * @param string $n <p>
 * </p>
 * @param string $p <p>
 * </p>
 * @return string
 */
function sodium_crypto_scalarmult(string $n, string $p): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Encrypt a message
 * @link http://php.net/manual/en/function.sodium-crypto-secretbox.php
 * @param string $string <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_secretbox(string $string, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-secretbox-keygen.php
 * @return string
 */
function sodium_crypto_secretbox_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Verify and decrypt a ciphertext
 * @link http://php.net/manual/en/function.sodium-crypto-secretbox-open.php
 * @param string $ciphertext <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_secretbox_open(string $ciphertext, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-secretstream-xchacha20poly1305-keygen.php
 * @return string
 */
function sodium_crypto_secretstream_xchacha20poly1305_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-secretstream-xchacha20poly1305-init-push.php
 * @param string $key <p>
 * </p>
 * @return array
 */
function sodium_crypto_secretstream_xchacha20poly1305_init_push(string $key): array {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-secretstream-xchacha20poly1305-push.php
 * @param string $state <p>
 * </p>
 * @param string $msg <p>
 * </p>
 * @param string $ad [optional] <p>
 * </p>
 * @param int $tag [optional] <p>
 * </p>
 * @return string
 */
function sodium_crypto_secretstream_xchacha20poly1305_push(string &$state, string $msg, string $ad = null, int $tag = null): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-secretstream-xchacha20poly1305-init-pull.php
 * @param string $header <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_secretstream_xchacha20poly1305_init_pull(string $header, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-secretstream-xchacha20poly1305-pull.php
 * @param string $state <p>
 * </p>
 * @param string $c <p>
 * </p>
 * @param string $ad [optional] <p>
 * </p>
 * @return array
 */
function sodium_crypto_secretstream_xchacha20poly1305_pull(string &$state, string $c, string $ad = null): array {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-secretstream-xchacha20poly1305-rekey.php
 * @param string $state <p>
 * </p>
 * @return void
 */
function sodium_crypto_secretstream_xchacha20poly1305_rekey(string &$state): void {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Compute a fixed-size fingerprint for the message
 * @link http://php.net/manual/en/function.sodium-crypto-shorthash.php
 * @param string $msg <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_shorthash(string $msg, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-shorthash-keygen.php
 * @return string
 */
function sodium_crypto_shorthash_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Sign a message
 * @link http://php.net/manual/en/function.sodium-crypto-sign.php
 * @param string $msg <p>
 * </p>
 * @param string $secret_key <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign(string $msg, string $secret_key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Sign the message
 * @link http://php.net/manual/en/function.sodium-crypto-sign-detached.php
 * @param string $msg <p>
 * </p>
 * @param string $keypair <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_detached(string $msg, string $keypair): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Convert an Ed25519 public key to a Curve25519 public key
 * @link http://php.net/manual/en/function.sodium-crypto-sign-ed25519-pk-to-curve25519.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_ed25519_pk_to_curve25519(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Convert an Ed25519 secret key to a Curve25519 secret key
 * @link http://php.net/manual/en/function.sodium-crypto-sign-ed25519-sk-to-curve25519.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_ed25519_sk_to_curve25519(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Randomly generate a secret key and a corresponding public key
 * @link http://php.net/manual/en/function.sodium-crypto-sign-keypair.php
 * @return string
 */
function sodium_crypto_sign_keypair(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-sign-keypair-from-secretkey-and-publickey.php
 * @param string $secret_key <p>
 * </p>
 * @param string $public_key <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_keypair_from_secretkey_and_publickey(string $secret_key, string $public_key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Check that the signed message has a valid signature
 * @link http://php.net/manual/en/function.sodium-crypto-sign-open.php
 * @param string $string <p>
 * </p>
 * @param string $keypair <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_open(string $string, string $keypair): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-sign-publickey.php
 * @param string $keypair <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_publickey(string $keypair): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-crypto-sign-secretkey.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_secretkey(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Extract the public key from the secret key
 * @link http://php.net/manual/en/function.sodium-crypto-sign-publickey-from-secretkey.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_publickey_from_secretkey(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Deterministically derive the key pair from a single key
 * @link http://php.net/manual/en/function.sodium-crypto-sign-seed-keypair.php
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_sign_seed_keypair(string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Verify signature for the message
 * @link http://php.net/manual/en/function.sodium-crypto-sign-verify-detached.php
 * @param string $signature <p>
 * </p>
 * @param string $msg <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return bool
 */
function sodium_crypto_sign_verify_detached(string $signature, string $msg, string $key): bool {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Generate a deterministic sequence of bytes from a seed
 * @link http://php.net/manual/en/function.sodium-crypto-stream.php
 * @param int $length <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_stream(int $length, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Get random bytes for key
 * @link http://php.net/manual/en/function.sodium-crypto-stream-keygen.php
 * @return string
 */
function sodium_crypto_stream_keygen(): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Encrypt a message
 * @link http://php.net/manual/en/function.sodium-crypto-stream-xor.php
 * @param string $msg <p>
 * </p>
 * @param string $nonce <p>
 * </p>
 * @param string $key <p>
 * </p>
 * @return string
 */
function sodium_crypto_stream_xor(string $msg, string $nonce, string $key): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Add large numbers
 * @link http://php.net/manual/en/function.sodium-add.php
 * @param string $val <p>
 * </p>
 * @param string $addv <p>
 * </p>
 * @return void No value is returned.
 */
function sodium_add(string &$val, string $addv): void {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Compare large numbers
 * @link http://php.net/manual/en/function.sodium-compare.php
 * @param string $buf1 <p>
 * </p>
 * @param string $buf2 <p>
 * </p>
 * @return int
 */
function sodium_compare(string $buf1, string $buf2): int {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Increment large number
 * @link http://php.net/manual/en/function.sodium-increment.php
 * @param string $val <p>
 * </p>
 * @return void
 */
function sodium_increment(string &$val): void {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Test for equality in constant-time
 * @link http://php.net/manual/en/function.sodium-memcmp.php
 * @param string $buf1 <p>
 * </p>
 * @param string $buf2 <p>
 * </p>
 * @return int
 */
function sodium_memcmp(string $buf1, string $buf2): int {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Overwrite buf with zeros
 * @link http://php.net/manual/en/function.sodium-memzero.php
 * @param string $buf <p>
 * </p>
 * @return void
 */
function sodium_memzero(string &$buf): void {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Add padding data
 * @link http://php.net/manual/en/function.sodium-pad.php
 * @param string $unpadded <p>
 * </p>
 * @param int $length <p>
 * </p>
 * @return string
 */
function sodium_pad(string $unpadded, int $length): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Remove padding data
 * @link http://php.net/manual/en/function.sodium-unpad.php
 * @param string $padded <p>
 * </p>
 * @param int $length <p>
 * </p>
 * @return string
 */
function sodium_unpad(string $padded, int $length): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Encode to hexadecimal
 * @link http://php.net/manual/en/function.sodium-bin2hex.php
 * @param string $bin <p>
 * </p>
 * @return string
 */
function sodium_bin2hex(string $bin): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Decodes a hexadecimally encoded binary string
 * @link http://php.net/manual/en/function.sodium-hex2bin.php
 * @param string $hex <p>
 * Hexadecimal representation of data.
 * </p>
 * @param string $ignore [optional] <p>
 * Optional string argument for characters to ignore.
 * </p>
 * @return string the binary representation of the given <i>hex</i> data.
 */
function sodium_hex2bin(string $hex, string $ignore = null): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-bin2base64.php
 * @param string $bin <p>
 * </p>
 * @param int $id <p>
 * </p>
 * @return string
 */
function sodium_bin2base64(string $bin, int $id): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Description
 * @link http://php.net/manual/en/function.sodium-base642bin.php
 * @param string $b64 <p>
 * </p>
 * @param int $id <p>
 * </p>
 * @param string $ignore [optional] <p>
 * </p>
 * @return string
 */
function sodium_base642bin(string $b64, int $id, string $ignore = null): string {}

/**
 * (PHP 7 &gt;= 7.2.0)<br/>
 * Alias of <b>sodium_crypto_box_publickey_from_secretkey</b>
 * @link http://php.net/manual/en/function.sodium-crypto-scalarmult-base.php
 * @param $string_1
 * @param $string_2
 */
function sodium_crypto_scalarmult_base($string_1, $string_2) {}

define ('SODIUM_LIBRARY_VERSION', "1.0.16");
define ('SODIUM_LIBRARY_MAJOR_VERSION', 10);
define ('SODIUM_LIBRARY_MINOR_VERSION', 1);
define ('SODIUM_CRYPTO_AEAD_AES256GCM_KEYBYTES', 32);
define ('SODIUM_CRYPTO_AEAD_AES256GCM_NSECBYTES', 0);
define ('SODIUM_CRYPTO_AEAD_AES256GCM_NPUBBYTES', 12);
define ('SODIUM_CRYPTO_AEAD_AES256GCM_ABYTES', 16);
define ('SODIUM_CRYPTO_AEAD_CHACHA20POLY1305_KEYBYTES', 32);
define ('SODIUM_CRYPTO_AEAD_CHACHA20POLY1305_NSECBYTES', 0);
define ('SODIUM_CRYPTO_AEAD_CHACHA20POLY1305_NPUBBYTES', 8);
define ('SODIUM_CRYPTO_AEAD_CHACHA20POLY1305_ABYTES', 16);
define ('SODIUM_CRYPTO_AEAD_CHACHA20POLY1305_IETF_KEYBYTES', 32);
define ('SODIUM_CRYPTO_AEAD_CHACHA20POLY1305_IETF_NSECBYTES', 0);
define ('SODIUM_CRYPTO_AEAD_CHACHA20POLY1305_IETF_NPUBBYTES', 12);
define ('SODIUM_CRYPTO_AEAD_CHACHA20POLY1305_IETF_ABYTES', 16);
define ('SODIUM_CRYPTO_AEAD_XCHACHA20POLY1305_IETF_KEYBYTES', 32);
define ('SODIUM_CRYPTO_AEAD_XCHACHA20POLY1305_IETF_NSECBYTES', 0);
define ('SODIUM_CRYPTO_AEAD_XCHACHA20POLY1305_IETF_NPUBBYTES', 24);
define ('SODIUM_CRYPTO_AEAD_XCHACHA20POLY1305_IETF_ABYTES', 16);
define ('SODIUM_CRYPTO_AUTH_BYTES', 32);
define ('SODIUM_CRYPTO_AUTH_KEYBYTES', 32);
define ('SODIUM_CRYPTO_BOX_SEALBYTES', 48);
define ('SODIUM_CRYPTO_BOX_SECRETKEYBYTES', 32);
define ('SODIUM_CRYPTO_BOX_PUBLICKEYBYTES', 32);
define ('SODIUM_CRYPTO_BOX_KEYPAIRBYTES', 64);
define ('SODIUM_CRYPTO_BOX_MACBYTES', 16);
define ('SODIUM_CRYPTO_BOX_NONCEBYTES', 24);
define ('SODIUM_CRYPTO_BOX_SEEDBYTES', 32);
define ('SODIUM_CRYPTO_KDF_BYTES_MIN', 16);
define ('SODIUM_CRYPTO_KDF_BYTES_MAX', 64);
define ('SODIUM_CRYPTO_KDF_CONTEXTBYTES', 8);
define ('SODIUM_CRYPTO_KDF_KEYBYTES', 32);
define ('SODIUM_CRYPTO_KX_SEEDBYTES', 32);
define ('SODIUM_CRYPTO_KX_SESSIONKEYBYTES', 32);
define ('SODIUM_CRYPTO_KX_PUBLICKEYBYTES', 32);
define ('SODIUM_CRYPTO_KX_SECRETKEYBYTES', 32);
define ('SODIUM_CRYPTO_KX_KEYPAIRBYTES', 64);
define ('SODIUM_CRYPTO_SECRETSTREAM_XCHACHA20POLY1305_ABYTES', 17);
define ('SODIUM_CRYPTO_SECRETSTREAM_XCHACHA20POLY1305_HEADERBYTES', 24);
define ('SODIUM_CRYPTO_SECRETSTREAM_XCHACHA20POLY1305_KEYBYTES', 32);
define ('SODIUM_CRYPTO_SECRETSTREAM_XCHACHA20POLY1305_MESSAGEBYTES_MAX', 274877906816);
define ('SODIUM_CRYPTO_SECRETSTREAM_XCHACHA20POLY1305_TAG_MESSAGE', 0);
define ('SODIUM_CRYPTO_SECRETSTREAM_XCHACHA20POLY1305_TAG_PUSH', 1);
define ('SODIUM_CRYPTO_SECRETSTREAM_XCHACHA20POLY1305_TAG_REKEY', 2);
define ('SODIUM_CRYPTO_SECRETSTREAM_XCHACHA20POLY1305_TAG_FINAL', 3);
define ('SODIUM_CRYPTO_GENERICHASH_BYTES', 32);
define ('SODIUM_CRYPTO_GENERICHASH_BYTES_MIN', 16);
define ('SODIUM_CRYPTO_GENERICHASH_BYTES_MAX', 64);
define ('SODIUM_CRYPTO_GENERICHASH_KEYBYTES', 32);
define ('SODIUM_CRYPTO_GENERICHASH_KEYBYTES_MIN', 16);
define ('SODIUM_CRYPTO_GENERICHASH_KEYBYTES_MAX', 64);
define ('SODIUM_CRYPTO_PWHASH_ALG_ARGON2I13', 1);
define ('SODIUM_CRYPTO_PWHASH_ALG_ARGON2ID13', 2);
define ('SODIUM_CRYPTO_PWHASH_ALG_DEFAULT', 2);
define ('SODIUM_CRYPTO_PWHASH_SALTBYTES', 16);
define ('SODIUM_CRYPTO_PWHASH_STRPREFIX', "$argon2id$");
define ('SODIUM_CRYPTO_PWHASH_OPSLIMIT_INTERACTIVE', 2);
define ('SODIUM_CRYPTO_PWHASH_MEMLIMIT_INTERACTIVE', 67108864);
define ('SODIUM_CRYPTO_PWHASH_OPSLIMIT_MODERATE', 3);
define ('SODIUM_CRYPTO_PWHASH_MEMLIMIT_MODERATE', 268435456);
define ('SODIUM_CRYPTO_PWHASH_OPSLIMIT_SENSITIVE', 4);
define ('SODIUM_CRYPTO_PWHASH_MEMLIMIT_SENSITIVE', 1073741824);
define ('SODIUM_CRYPTO_PWHASH_SCRYPTSALSA208SHA256_SALTBYTES', 32);
define ('SODIUM_CRYPTO_PWHASH_SCRYPTSALSA208SHA256_STRPREFIX', "$7$");
define ('SODIUM_CRYPTO_PWHASH_SCRYPTSALSA208SHA256_OPSLIMIT_INTERACTIVE', 524288);
define ('SODIUM_CRYPTO_PWHASH_SCRYPTSALSA208SHA256_MEMLIMIT_INTERACTIVE', 16777216);
define ('SODIUM_CRYPTO_PWHASH_SCRYPTSALSA208SHA256_OPSLIMIT_SENSITIVE', 33554432);
define ('SODIUM_CRYPTO_PWHASH_SCRYPTSALSA208SHA256_MEMLIMIT_SENSITIVE', 1073741824);
define ('SODIUM_CRYPTO_SCALARMULT_BYTES', 32);
define ('SODIUM_CRYPTO_SCALARMULT_SCALARBYTES', 32);
define ('SODIUM_CRYPTO_SHORTHASH_BYTES', 8);
define ('SODIUM_CRYPTO_SHORTHASH_KEYBYTES', 16);
define ('SODIUM_CRYPTO_SECRETBOX_KEYBYTES', 32);
define ('SODIUM_CRYPTO_SECRETBOX_MACBYTES', 16);
define ('SODIUM_CRYPTO_SECRETBOX_NONCEBYTES', 24);
define ('SODIUM_CRYPTO_SIGN_BYTES', 64);
define ('SODIUM_CRYPTO_SIGN_SEEDBYTES', 32);
define ('SODIUM_CRYPTO_SIGN_PUBLICKEYBYTES', 32);
define ('SODIUM_CRYPTO_SIGN_SECRETKEYBYTES', 64);
define ('SODIUM_CRYPTO_SIGN_KEYPAIRBYTES', 96);
define ('SODIUM_CRYPTO_STREAM_NONCEBYTES', 24);
define ('SODIUM_CRYPTO_STREAM_KEYBYTES', 32);
define ('SODIUM_BASE64_VARIANT_ORIGINAL', 1);
define ('SODIUM_BASE64_VARIANT_ORIGINAL_NO_PADDING', 3);
define ('SODIUM_BASE64_VARIANT_URLSAFE', 5);
define ('SODIUM_BASE64_VARIANT_URLSAFE_NO_PADDING', 7);

// End of sodium v.7.2.7-0ubuntu0.18.04.2
?>
